######################################################## 
## MOD Title: EasyBAN MOD
## MOD Author: maraja < maraja@users.sourceforge.net > (Ugo Grandolini aka 'maraja') http://easyban.sourceforge.net/
## MOD Description: A tool to easily handle spam in phpBB forums
## MOD Version: 0.1.2
## 
## Installation Level: Easy
## Installation Time: ~15 min (less than 1 min with EasyMOD 0.3.0) 
##
## Files To Edit: 8
##  posting.php
##  viewtopic.php
##  viewforum.php
##  includes/constants.php
##  includes/topic_review.php
##  templates/subSilver/subSilver.cfg
##  templates/subSilver/viewtopic_body.tpl
##  templates/subSilver/viewforum_body.tpl
##
## Included Files: 19
##  EasyBAN_INSTALL.mod
##  EasyBAN_MNGR.php
##  EasyBAN_README.txt
##  admin/admin_EasyBAN.php
##  admin/EasyBAN_includes/EasyBAN_functions.php
##  admin/EasyBAN_includes/EasyBAN_HIDER.php
##  admin/EasyBAN_includes/EasyBAN_links.php
##  admin/EasyBAN_includes/index.htm
##  language/lang_english/lang_EasyBAN_MNGR.php
##  templates/subSilver/admin/EasyBAN_admin.tpl
##  templates/subSilver/admin/EasyBAN_details.tpl
##  templates/subSilver/admin/EasyBAN_footer.tpl
##  templates/subSilver/admin/EasyBAN_header.tpl
##  templates/subSilver/admin/EasyBAN_help.tpl
##  templates/subSilver/admin/EasyBAN_settings.tpl
##  templates/subSilver/admin/EasyBAN_update_results.tpl
##  templates/subSilver/admin/images/icon_ban.gif
##  templates/subSilver/admin/images/icon_quarantine.gif
##  templates/subSilver/admin/images/EasyBAN_logo.gif
##
##
## License: http://opensource.org/licenses/gpl-license.php GNU General Public License v2 
################################################################# 
## For security purposes, please check: http://www.phpbb.com/mods/
## for the latest version of this MOD. Although MODs are checked
## before being allowed in the MODs Database there is no guarantee
## that there are no security problems within the MOD. No support
## will be given for MODs not found within the MODs Database which
## can be found at http://www.phpbb.com/mods/
############################################################## 
##
## Author Notes:
##
## 	Tested on 2.0.21. Can be installed using EasyMOD 0.3.0
##
############################################################## 
## MOD History: 
##
##   2006-11-16 - Version 0.1.0
##      - Initial Release.
##
##   2006-12-08 - Version 0.1.1
##      - Re-release to make EasyBAN compliant with the official MODs requirements.
##
##   2006-12-09 - Version 0.1.2
##      - Bug fixes:
##          > handling of the 'hide all topics/posts' setting was not working.
##          > only the user name was properly banned.
##      - Improvements:
##          > the words can be extended by adding, in the admin/EasyBAN_includes directory, a file named "quarantine_words.txt". 
##            The file must be pure ascii text and include one word per line.
##          > the words list is also checked against:
##              * the topic title, if found the entire topic is hidden;
##              * the post subject, if found the post is hidden.
##          > it is now possible to quarantine posts that includes even one single link; please do not forget to amend 
##            your 'Max allowed number of links' settings to 999 if you like to let users posts an unlimited number of links.
##          > the email also shows the topic title.
##
##
############################################################## 
## Before Adding This MOD To Your Forum, You Should Back Up All Files Related To This MOD 
##############################################################

#
#-----[ COPY ]------------------------------------------
#
copy EasyBAN_MNGR.php to EasyBAN_MNGR.php
copy admin/admin_EasyBAN.php to admin/admin_EasyBAN.php
copy admin/EasyBAN_includes/*.* to admin/EasyBAN_includes/*.*
copy language/lang_english/lang_EasyBAN.php to language/lang_english/lang_EasyBAN.php
copy templates/subSilver/admin/*.* to templates/subSilver/admin/*.*
copy templates/subSilver/images/*.* to templates/subSilver/images/*.*

#
#-----[ DIY INSTRUCTIONS ]------------------------------------------
#
You need to run one of the following SQL commands to create or amend the hided table.
 
If you are installing EasyMOD for the first time:
CREATE TABLE `phpbb_hided` ( `hide_id` mediumint(8) unsigned default '0', `hide_quar` int(1) unsigned NOT NULL default '0', `hide_type` int(1) unsigned NOT NULL default '0', UNIQUE KEY `hide_id` (`hide_id`,`hide_type`) );

If you are upgrading from EasyMOD 0.1.1:
ALTER TABLE `phpbb_hided` ADD UNIQUE `hide_id` (`hide_id`, `hide_type`);

#=======================================================
#
#-----[ OPEN ]------------------------------------------
#
# TO GET AN EMAIL FOR EACH NEW/EDIT POST
#
posting.php
#
#-----[ FIND ]------------------------------------------
#
				submit_post($mode, $post_data, $return_message, $return_meta, $forum_id, $topic_id, $post_id, $poll_id, $topic_type, $bbcode_on, $html_on, $smilies_on, $attach_sig, $bbcode_uid, str_replace("\'", "''", $username), str_replace("\'", "''", $subject), str_replace("\'", "''", $message), str_replace("\'", "''", $poll_title), $poll_options, $poll_length);
			}
#
#-----[ AFTER, ADD ]------------------------------------------
#
			include($phpbb_root_path . 'admin/EasyBAN_includes/EasyBAN_HIDER.php');	/*---| added by EasyBAN |---*/
			easyban_hider(); /*---| added by EasyBAN |---*/

#=======================================================
#
#-----[ OPEN ]------------------------------------------
#
viewtopic.php
#
#-----[ FIND ]------------------------------------------
#
include($phpbb_root_path . 'includes/bbcode.'.$phpEx);

#
#-----[ AFTER, ADD ]------------------------------------------
#
/*---| added by EasyBAN -- BEG OF BLOCK |---*/
if ( @file_exists($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_EasyBAN.' . $phpEx) )
{
	include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_EasyBAN.' . $phpEx);
}
else
{
	include($phpbb_root_path . 'language/lang_english/lang_EasyBAN.' . $phpEx);
}
include($phpbb_root_path . 'admin/EasyBAN_includes/EasyBAN_links.' . $phpEx);
/*---| added by EasyBAN -- END OF BLOCK |---*/


#-----[ FIND ]------------------------------------------
#
$postrow = array();
#
#-----[ AFTER, ADD ]------------------------------------------
#
$e = 0;	$q = 0; /*---| added by EasyBAN |---*/
#
#-----[ FIND ]------------------------------------------
#
		$postrow[] = $row;
#
#-----[ BEFORE, ADD ]------------------------------------------
#
		/*---| do loop changed by EasyBAN |---*/
		$sql = 'SELECT * FROM ' . HIDED_TABLE . ' 
				WHERE 
				hide_id = ' . $row['post_id'] . ' AND 
				hide_type = 0';
		if( !$tmpresult = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, $lang['EasyBAN_err_no_hided'] . $row['post_id'], '', __LINE__, __FILE__, $sql);
		}
		$tmp = $db->sql_fetchrow($tmpresult);
		if($tmp['hide_id'] != $row['post_id'])
		{
			//	show the post only if there are NO record(s) in the hide post table
			//
#
#-----[ AFTER, ADD ]------------------------------------------
#
		}
		else
		{
			// count hidden rows
			//
			if( $tmp['hide_quar'] == 0 )
			{
				$e++; // hided
			}
			else
			{
				$q++; // quarantined
			}
		}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#
#	The final look on a clean 2.0.21 install should be:
#
#	do
#	{
#		/*---| do loop changed by EasyBAN |---*/
#		$sql = 'SELECT * FROM ' . HIDED_TABLE . ' 
#				WHERE 
#				hide_id = ' . $row['post_id'] . ' AND 
#				hide_type = 0';
#		if( !$tmpresult = $db->sql_query($sql) )
#		{
#			message_die(GENERAL_ERROR, $lang['EasyBAN_err_no_hided'] . $row['post_id'], '', __LINE__, __FILE__, $sql);
#		}
#		$tmp = $db->sql_fetchrow($tmpresult);
#		if($tmp['hide_id'] != $row['post_id'])
#		{
#			//	show the post only if there are NO record(s) in the hide post table
#			//
#			$postrow[] = $row;
#		}
#		else
#		{
#			// count hidden rows
#			//
#			if( $tmp['hide_quar'] == 0 )
#			{
#				$e++; // hided
#			}
#			else
#			{
#				$q++; // quarantined
#			}
#		}
#	}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#
#-----[ FIND ]------------------------------------------
#
		$delpost = '<a href="' . $temp_url . '">' . $lang['Delete_post'] . '</a>';
#
#-----[ AFTER, ADD ]------------------------------------------
#
		/*---| added by EasyBAN -- BEG OF BLOCK |---*/
 		$temp_url = $easyban_links['HIDER'] . "&amp;page=full&amp;pid=" . $postrow[$i]['post_id'] . '&amp;sid=' . $userdata['session_id'] . "&amp;act=i";
		if( $poster_id != ANONYMOUS )
		{
			$temp_url .= 'ue';
		}
		if( $userdata['session_admin'] != 1 )
		{
			$temp_url = 'login.' . $phpEx . '?redirect=' . str_replace('?', '&amp;', $temp_url) . '&amp;admin=1';
		}
		$ban_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_ban'] . '" alt="' . $lang['EasyBAN_alt_post'] . '" title="' . $lang['EasyBAN_alt_post'] . '" border="0" /></a>';
		$banpost = '<a href="' . $temp_url . '">' . $lang['EasyBAN_alt_post'] . '</a>';
		/*---| added by EasyBAN -- END OF BLOCK |---*/

#
#-----[ FIND ]------------------------------------------
#
		$ip = '';

#
#-----[ AFTER, ADD ]------------------------------------------
#
		$ban_img = '';	/*---| added by EasyBAN |---*/
		$banpost = '';	/*---| added by EasyBAN |---*/

#
#-----[ FIND ]------------------------------------------
#
		'DELETE' => $delpost,

#
#-----[ AFTER, ADD ]------------------------------------------
#
		'BAN_IMG' => $ban_img,	/*---| added by EasyBAN |---*/
		'BANPOST' => $banpost,	/*---| added by EasyBAN |---*/

#
#-----[ FIND ]------------------------------------------
#
$template->pparse('body');

#
#-----[ BEFORE, ADD ]------------------------------------------
#
/*---| added by EasyBAN -- BEG OF BLOCK |---*/
$tmp = '<p class="quote" style="padding:8px;margin:0px;">';
if( $e > 0 )
{
	$tmp .= '<b>' . $e . '</b> ' . $lang['EasyBAN_pban'];
	if( $q > 0 ) { $tmp .= ','; }
}
if( $q > 0 )
{
	$tmp .= ' <b>' . $q . '</b> ' . $lang['EasyBAN_pqua'];
}
if( ($e > 0) || ($q > 0) )
{
	$tmp .= $lang['EasyBAN_by'] . '<a href="' . $easyban_links['SITE'] . '" target="_blank">EasyBAN</a>!';
	if ( $userdata['user_email'] == $board_config['board_email'] )
	{
		//	add link to EasyBAN manager for the Admin
		//
		$tmp .= '<br /><a href="' . $easyban_links['ADMIN'] . '&amp;page=full&amp;sid=' . $userdata['session_id'] . '">' . $lang['EasyBAN_mngm'] . '</a>';
	}
	$tmp .= '</p>';
	$template->assign_vars(array('HIDED_INFO' => $tmp));
}
/*---| added by EasyBAN -- END OF BLOCK |---*/

#=======================================================
#
#-----[ OPEN ]------------------------------------------
#
viewforum.php
#
#-----[ FIND ]------------------------------------------
#
include($phpbb_root_path . 'common.'.$phpEx);
#
#-----[ AFTER, ADD ]------------------------------------------
#
/*---| added by EasyBAN -- BEG OF BLOCK |---*/
if ( @file_exists($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_EasyBAN.' . $phpEx) )
{
	include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_EasyBAN.' . $phpEx);
}
else
{
	include($phpbb_root_path . 'language/lang_english/lang_EasyBAN.' . $phpEx);
}
include($phpbb_root_path . 'admin/EasyBAN_includes/EasyBAN_links.' . $phpEx);
/*---| added by EasyBAN -- END OF BLOCK |---*/

#
#-----[ FIND ]------------------------------------------
#
$sql = "SELECT t.*, u.username, u.user_id, u2.username as user2, u2.user_id as id2, p.post_username, p2.post_username AS post_username2, p2.post_time 
#
#-----[ AFTER, ADD ]------------------------------------------
#
	, p.post_id /*---| added by EasyBAN |---*/
#
#-----[ FIND ]------------------------------------------
#
$total_topics = 0;
#
#-----[ AFTER, ADD ]------------------------------------------
#
$e = 0;	$q = 0; /*---| added by EasyBAN |---*/
#
#-----[ FIND ]------------------------------------------
#
	$topic_rowset[] = $row;
#
#-----[ BEFORE, ADD ]------------------------------------------
#
	/*---| loop changed by EasyBAN |---*/
	$sql = 'SELECT * FROM ' . HIDED_TABLE . ' 
			WHERE
			hide_id = ' . $row['topic_id'] . ' AND 
			hide_type = 1 ';
	if( !$tmpresult = $db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, $lang['EasyBAN_err_no_hided'] . $row['post_id'], '', __LINE__, __FILE__, $sql);
	}
	$tmp = $db->sql_fetchrow($tmpresult);
	if( $tmp['hide_id'] != $row['topic_id'] )
	{
		//	show the post only if there are NO record(s) in the hide post table
		//
#
#-----[ FIND ]------------------------------------------
#
		$total_topics++;
#
#-----[ AFTER, ADD ]------------------------------------------
#
	}
	else
	{
		// count hidden rows
		//
		if( $tmp['hide_quar'] == 0 )
		{
			$e++; // hided
		}
		else
		{
			$q++; // quarantined
		}
	}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#
#	The final look on a clean 2.0.21 install should be:
#
#	while( $row = $db->sql_fetchrow($result) )
#	{
#		/*---| loop changed by EasyBAN |---*/
#		$sql = 'SELECT * FROM ' . HIDED_TABLE . ' 
#				WHERE
#				hide_id = ' . $row['topic_id'] . ' AND 
#				hide_type = 1 ';
#		if( !$tmpresult = $db->sql_query($sql) )
#		{
#			message_die(GENERAL_ERROR, $lang['EasyBAN_err_no_hided'] . $row['post_id'], '', __LINE__, __FILE__, $sql);
#		}
#		$tmp = $db->sql_fetchrow($tmpresult);
#		if( $tmp['hide_id'] != $row['topic_id'] )
#		{
#			//	show the post only if there are NO record(s) in the hide post table
#			//
#			$topic_rowset[] = $row;
#			$total_topics++;
#		}
#		else
#		{
#			// count hidden rows
#			//
#			if( $tmp['hide_quar'] == 0 )
#			{
#				$e++; // hided
#			}
#			else
#			{
#				$q++; // quarantined
#			}
#		}
#	}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#
#-----[ FIND ]------------------------------------------
#
		$row_class = ( !($i % 2) ) ? $theme['td_class1'] : $theme['td_class2'];
#
#-----[ AFTER, ADD ]------------------------------------------
#
		/*---| added by EasyBAN -- BEG OF BLOCK |---*/
		if ( $userdata['user_email'] == $board_config['board_email'] )
		{
			$temp_url = $easyban_links['HIDER'] . "&amp;page=full&amp;tid=" . $topic_id . '&amp;sid=' . $userdata['session_id'] . "&amp;act=i";
			if( $topic_rowset[$i]['user_id'] != ANONYMOUS )
			{
				$temp_url .= 'ue';
			}
			if( $userdata['session_admin'] != 1 )
			{
				$temp_url = 'login.' . $phpEx . '?redirect=' . str_replace('?', '&amp;', $temp_url) . '&amp;admin=1';
			}
			$ban_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_ban'] . '" alt="' . $lang['EasyBAN_alt_topic'] . '" title="' . $lang['EasyBAN_alt_topic'] . '" border="0" align="absmiddle" /></a>';
			$banpost = '<a href="' . $temp_url . '">' . $lang['EasyBAN_alt_topic'] . '</a>';
		}
		else
		{
			$ban_img = '';
			$banpost = '';
		}
		/*---| added by EasyBAN -- END OF BLOCK |---*/
#
#-----[ FIND ]------------------------------------------
#
			'U_VIEW_TOPIC' => $view_topic_url)
#
#-----[ BEFORE, ADD ]------------------------------------------
#
			'BAN_IMG' => $ban_img,					/*---| added by EasyBAN |---*/
			
#
#-----[ FIND ]------------------------------------------
#
//
// Parse the page and print
//
$template->pparse('body');
#
#-----[ BEFORE, ADD ]------------------------------------------
#

/*---| added by EasyBAN -- BEG OF BLOCK |---*/
$tmp = '<p class="quote" style="padding:8px;margin:0px;">';
if( $e > 0 )
{
	$tmp .= '<b>' . $e . '</b> ' . $lang['EasyBAN_tban'];
	if( $q > 0 ) { $tmp .= ','; }
}
if( $q > 0 )
{
	$tmp .= ' <b>' . $q . '</b> ' . $lang['EasyBAN_tqua'];
}
if( ($e > 0) || ($q > 0) )
{
	$tmp .= $lang['EasyBAN_by'] . '<a href="' . $easyban_links['SITE']. '" target="_blank">EasyBAN</a>!';
	if ( $userdata['user_email'] == $board_config['board_email'] )
	{
		//	add link to EasyBAN manager for the Admin
		//
		$tmp .= '<br /><a href="' . $easyban_links['ADMIN'] . '&amp;page=full&amp;sid=' . $userdata['session_id'] . '">' . $lang['EasyBAN_mngm'] . '</a>';
	}
	$tmp .= '</p>';
	$template->assign_vars(array('HIDED_INFO' => $tmp));
}
/*---| added by EasyBAN -- END OF BLOCK |---*/

#=======================================================
#
#-----[ OPEN ]------------------------------------------
#
includes/constants.php
#
#-----[ FIND ]------------------------------------------
#
?>
# 
#-----[ BEFORE, ADD ]------------------------------------------
#
define('HIDED_TABLE', $table_prefix.'hided');	/*---| added by EasyBAN |---*/

#=======================================================
#
#-----[ OPEN ]------------------------------------------
#
includes/topic_review.php
#
#-----[ FIND ]------------------------------------------
#
		do
		{
#
#-----[ AFTER, ADD ]------------------------------------------
#
			/*---| added by EasyBAN -- BEG OF BLOCK |---*/
			$sql = 'SELECT * FROM ' . HIDED_TABLE . ' 
					WHERE
					hide_id = ' . $row['post_id'] . ' AND 
					hide_type = 0 ';
			if( !$tmpresult = $db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, $lang['EasyBAN_err_no_hided'] . $row['post_id'], '', __LINE__, __FILE__, $sql);
			}
			$tmp = $db->sql_fetchrow($tmpresult);
			if($tmp['hide_id'] != $row['post_id'])
			{
				//	show the post only if there are NO record(s) in the hide post table
				//
				/*---| added by EasyBAN -- END OF BLOCK |---*/
#
#-----[ FIND ]------------------------------------------
#
			$i++;
#
#-----[ AFTER, ADD ]------------------------------------------
#
				/*---| added by EasyBAN -- BEG OF BLOCK |---*/
			}
			else
			{
				$e++;
			}
			/*---| added by EasyBAN -- END OF BLOCK |---*/

#=======================================================
#
#-----[ OPEN ]------------------------------------------
#
templates/subSilver/subSilver.cfg
#
#-----[ FIND ]------------------------------------------
#
$images['voting_graphic'][4] = "$current_template_images/voting_bar.gif";
# 
#-----[ AFTER, ADD ]------------------------------------------ 
#
 
$images['icon_ban'] = "$current_template_images/icon_ban.gif";			/*---| added by EasyBAN |---*/
$images['icon_quar'] = "$current_template_images/icon_quarantine.gif";	/*---| added by EasyBAN |---*/
$images['EasyBAN_logo'] = "$current_template_images/EasyBAN_logo.gif";	/*---| added by EasyBAN |---*/

#=======================================================
#
#-----[ OPEN ]------------------------------------------
#
templates/subSilver/viewtopic_body.tpl
#
#-----[ FIND ]------------------------------------------
#
{postrow.IP_IMG}
#
#-----[ IN-LINE FIND ]------------------------------------------
#
.IP_IMG}
#
#-----[ IN-LINE AFTER, ADD ]------------------------------------------
#
 {postrow.BAN_IMG}<!-- changed by EasyBAN -->
#
#-----[ FIND ]------------------------------------------
#
	<!-- END postrow -->
#
#-----[ AFTER, ADD ]------------------------------------------
#
	<tr align="center"><td class="spaceRow" colspan="2">{HIDED_INFO}<!-- added by EasyBAN --></td></tr>

#=======================================================
#
#-----[ OPEN ]------------------------------------------
#
templates/subSilver/viewforum_body.tpl
#
#-----[ FIND ]------------------------------------------
#
{topicrow.LAST_POST_IMG}
#
#-----[ IN-LINE FIND ]------------------------------------------
#
.LAST_POST_IMG}
#
#-----[ IN-LINE AFTER, ADD ]------------------------------------------
#
 {topicrow.BAN_IMG}<!-- added by EasyBAN -->
#
#-----[ FIND ]------------------------------------------
#
	<!-- END switch_no_topics -->
#
#-----[ AFTER, ADD ]------------------------------------------
#
	<tr align="center"><td class="spaceRow" colspan="6">{HIDED_INFO}<!-- added by EasyBAN --></td></tr>
#
#-----[ SAVE/CLOSE ALL FILES ]------------------------------------------
#
# EoM